import { DatabaseAdapter } from '@lucidcms/core';
import { DatabaseConfig, KyselyDB, InferredTable } from '@lucidcms/core/types';
import pg from 'pg';
import { ColumnDataType } from 'kysely';
import { jsonArrayFrom } from 'kysely/helpers/postgres';

declare class PostgresAdapter extends DatabaseAdapter {
    constructor(config: pg.PoolConfig);
    initialise(): Promise<void>;
    get jsonArrayFrom(): typeof jsonArrayFrom;
    get config(): DatabaseConfig;
    inferSchema(tx?: KyselyDB): Promise<InferredTable[]>;
    formatDefaultValue(type: ColumnDataType, value: unknown): unknown;
}

export { PostgresAdapter as default };
